// Copyright  2016-2020, Stefan Kanthak <stefan.kanthak@nexgo.de>

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

#ifdef DLL
#pragma comment(linker, "/DEFAULTLIB:KERNEL32.LIB")
#pragma comment(linker, "/DLL")
#pragma comment(linker, "/ENTRY:_DllMainCRTStartup")
#pragma comment(linker, "/EXPORT:_FUBAR,DATA")
#pragma comment(linker, "/SUBSYSTEM:CONSOLE")

__declspec(dllexport)
const	CHAR	FUBAR[] = "Fucked up beyond all recognition\b\b\b\b\b\b\b\b\b\b\b\b\b\b\bmessage identifier 0x8020000B\n";

const	LPCSTR	szReason[4] = {"DLL_PROCESS_DETACH\n",
		               "DLL_PROCESS_ATTACH\n",
		               "DLL_THREAD_ATTACH\n",
		               "DLL_THREAD_DETACH\n"};

BOOL	WINAPI	_DllMainCRTStartup(HANDLE hModule, DWORD  dwReason, LPVOID lpReserved)
{
#ifdef VERBOSE
	DWORD	dwConsole;

	WriteConsoleA(GetStdHandle(STD_ERROR_HANDLE), szReason[dwReason], lstrlenA(szReason[dwReason]), &dwConsole, NULL);
#else
	OutputDebugStringA(szReason[dwReason]);
#endif
	return FALSE;
}
#else
#pragma comment(linker, "/DEFAULTLIB:FUBAR.LIB")
#pragma comment(linker, "/DEFAULTLIB:KERNEL32.LIB")
#pragma comment(linker, "/ENTRY:mainCRTStartup")
#pragma comment(linker, "/SUBSYSTEM:CONSOLE")

__declspec(dllimport)
extern	const	CHAR	FUBAR[];

__declspec(noreturn)
VOID	WINAPI	mainCRTStartup(VOID)
{
#ifdef VERBOSE
	DWORD	dwConsole;

	WriteConsoleA(GetStdHandle(STD_ERROR_HANDLE), FUBAR, lstrlenA(FUBAR), &dwConsole, NULL);
#else
	OutputDebugStringA(FUBAR);
#endif
	ExitProcess(GetLastError());
}
#endif
